
 If CHDIR("out") Then
   MKDIR("out")
   Print "Subfolder /out created for output of SPACS."
 Else
   CHDIR("..")
 End If  

 Redim As Single Zsum(120), Asum(300)

 Scope
   Dim As String Cpost
   Cpost = "_Z" + Trim(Str(Int(Zp))) + "_A" + Trim(Str(Int(Ap))) + _ 
         "_" + Ctarget + "_" + Trim(Str(Int(Ep))) + "MeV"
   Dim As Integer I,J,f,Np

   Np = Ap - Zp
  
   For I = 1 To Zp + Zt + 2
     For J = 1 To Np + 2
       Zsum(I) = Zsum(I) + R_XSS(J,I)
     Next J
   Next I
   
   For I = 1 To Np + 2
     For J = 1 To Zp + Zt + 2
       Asum(I+J) = Asum(I+J) + R_XSS(I,J)
     Next J
   Next I
 
   f = freefile
   Open "out/SPACS"+Cpost+".dmp" For Append As #f
 
   For I = 1 To Zp + Zt + 2
     If Zsum(I) > 0 Then
       Print #f, "C: SPACS"
       Print #f, "S: Analyzer(N(";Str(I);"))"
       Print #f, "C: Isotopic distribution for Z = ";Int(I)
       Print #f, "C: Energy: ";Int(Ep);" MeV"
       Print #f, "C: Heavy reaction partner: Z = ";Int(Zp);", A = ";Int(Ap)
       Print #f, "C: + ";Ctarget
       Print #f, "X: Neutron number"
       Print #f, "Y: si^ / mb"
       Print #f, " "
       Print #f, "A:  X   Y,LTR1"
       For J = 1 To Np + 2
         If R_XSS(J,I) > 1.E-20 Then
           Print #f, J,R_XSS(J,I)
         End If
       Next
       Print #f, " "
       Print #f, " " 
     End If
   Next
 
  
   Print #f, "S: Analyzer(Z)"
   Print #f, "C: Z distribution"
   Print #f, "X: Atomic number"
   Print #f, "Y: si^ / mb"
   Print #f, " "
   Print #f, "A:  X   Y,LTG1"
   For J = 1 To Zp + 2
     If Zsum(J) > 1.E-20 Then
       Print #f, J,Zsum(J)
     End If
   Next 
 
   Print #f, " "
   Print #f, " " 
 
   Print #f, "S: Analyzer(A)"
   Print #f, "C: A distribution"
   Print #f, "X: Mass number"
   Print #f, "Y: si^ / mb"
   Print #f, " "
   Print #f, "A:  X   Y,LTB1"
   For J = 1 To Ap + 2
     If Asum(J) > 1.E-20 Then
       Print #f, J,Asum(J)
     End If
   Next  
 
  
   Close #f
 End Scope

 Print
 Print "<I> Analyzer dmp files with calculated cross sections are written."
