 /' Plot of mass distribution (Plotting.bas) '/

Declare Sub Logcircle(X As Single, Y As Single, R As Single)
Declare Sub Lincircle(X As Single, Y As Single, R As Single)
Declare Sub Logline1(X1 As Single, Y1 As Single, X2 As Single, Y2 As Single)
Declare Sub Logline2(X As Single, Y As Single)
Declare Sub Logcross(X As Single, Y As Single, DY As Single)




 ' set window title
Dim WinTitle As String
WinTitle = "SPACS: Z="+Str(Zp)+", A="+Str(Ap)
WinTitle = WinTitle+" + "+"p" 
WinTitle = WinTitle+" (E="+Str(Ep)+"MeV)"

' create a window with given resolution and 32-bit colours
Screenres 500,680,32
WindowTitle WinTitle

' set foreground and background colours
Color RGB(0,0,0), RGB(255,255,255)
' draw background
Cls

Declare Function Ticdistlin(rmin As Single,rmax As Single, _
      runit As Single,rscale As Single) As Single

Declare Function Ticdistlog(rmin As Single,rmax As Single, _
      runit As Single,rscale As Single) As Single

Function Ticdistlin(rmin As Single,rmax As Single, _
      runit As Single, rscale As Single) As Single
  /' runit not yet supported '/    
  Dim As Single dr,rp10,drn,drtic    
  dr = rmax - rmin    ' range
  rp10 =  Int(log(dr)/log(10))  ' power of 10
  drn = dr / 10^rp10    ' normalized range (between 1 and 9.999)
  If drn/rscale <= 2 Then
    drtic = 0.2  
  ElseIf drn/rscale <= 5 Then
    drtic = 0.5
  Else ' drn/rscale > 5
    drtic = 1
  End If
  Ticdistlin = drtic * 10^rp10
 End Function

Function Ticdistlog(rmin As Single,rmax As Single, _
      runit As Single, rscale As Single) As Single
      Ticdistlog = 0
End Function


/' Z distribution '/

Declare Sub CreateFrame (Cxaxis As String, Cyaxis As String, _
  Xmin As Single, Xmax As Single, xlinlog As Ubyte, _
  Ymin As Single, Ymax As Single, ylinlog As Ubyte, _
  xpix1 As Integer, xpix2 As Integer, ypix1 As Integer, ypix2 As Integer) 
  
Sub CreateFrame (Cxaxis As String, Cyaxis As String, _
      Xmin As Single, Xmax As Single, xlinlog As Ubyte, _
      Ymin As Single, Ymax As Single, ylinlog As Ubyte, _
      xpix1 As Integer,xpix2 As Integer,ypix1 As Integer,ypix2 As Integer)

  Dim As Single xpix,ypix,dxtic,xtic0,xtic,ytic
  Dim As String cxtic,cytic

  
  /'*** Write Captions of axes ***'/

  /' Write Cyaxis '/
  xpix = xpix1 - 26- 8*Len(Cyaxis)
  If xpix < 2 Then xpix = 2
  ypix = (ypix1 + ypix2)/2
  Draw String(xpix,ypix),Cyaxis
    
  /' Write Cxaxis '/
  xpix = (xpix1 + xpix2)/2 - 8*Len(Cxaxis)/2
  ypix = ypix2 + 25
  Draw String(xpix,ypix),Cxaxis 
  
  
  /'** Write tic numbers ***'/
  
  /' Linear x axis '/
  If xlinlog = 0 Then
    dxtic = Ticdistlin(Xmin,Xmax,10,1)
    /' Write numbers on tic marks, x axis '/
    xtic0 = Int(Xmin / dxtic) * dxtic
    If xtic0 < Xmin Then xtic0 = xtic0 + dxtic
  
    For xtic = xtic0 To Xmax Step dxtic
      If xtic = Int(xtic) then
        cxtic = Trim(Str(Int(xtic)))
      Else
        cxtic = Trim(Str(xtic))
      End If   
      xpix = (xpix2-xpix1)/(Xmax-Xmin)*(xtic-Xmin)+xpix1-8*Len(cxtic)/2
      Draw String (xpix,ypix2+8), cxtic
    Next
  End If
  
  /' Logarithmic x axis '/
  If xlinlog = 1 Then
  
  End If
  
  /' Linear y axis '/
  If ylinlog = 0 Then
  
  End If
  
  /' Logarithmic y axis '/
  If ylinlog = 1 Then
    For ytic = Int(Log10(ymin)-1) To Log10(ymax) Step 1
      If ytic >= Log10(ymin) Then
        cytic = str(10^ytic)
        xpix = xpix1 - 4 - 8*len(cytic)
        ypix = (ypix1-ypix2)/(log10(ymax)-log10(ymin))*(ytic-ymin+1)+ypix2-12
        Draw String (xpix,ypix), cytic
      End If
    Next
  End If
  
End Sub    

Declare Sub CreateArea (Xmin As Single, Xmax As Single, xlinlog As Ubyte, _
                        Ymin As Single, Ymax As Single, ylinlog As Ubyte, _
                        xpix1 As Single, xpix2 As Single, _
                        ypix1 As Single, ypix2 As Single)  

Sub CreateArea(Xmin As Single, Xmax As Single, xlinlog As Ubyte, _
                        Ymin As Single, Ymax As Single, ylinlog As Ubyte,_
                        xpix1 As Single, xpix2 As Single, _
                        ypix1 As Single, ypix2 As Single)  
                        
       
   Dim As Single Xmin_used,Xmax_used,Ymin_used,Ymax_used    
       
  /'*** Define Viewport ***'/
  View (xpix1,ypix1) - (xpix2,ypix2), RGB(255,255,150), RGB(0,0,0) 

   If xlinlog = 0 Then 
      Xmin_used = Xmin
      Xmax_used = Xmax
   Else
      Xmin_used = Log10(Xmin)
      Xmax_used = Log10(Xmax)
   End If
   If ylinlog = 0 Then
      Ymin_used = Ymin
      Ymax_used = Ymax
   Else
      Ymin_used = Log10(Ymin)
      Ymax_used = Log10(Ymax)   
   End If       
       
   Window (Xmin,log10(Ymin)) - (Xmax, log10(Ymax)) 
  
  /'*** Draw tic marks and lines ***'/
  
  Dim as Single dxtic,xtic0
  Dim xtic As Single
  If xlinlog = 0 Then
  /' Linear x scale '/
  /' Draw vertical lines '/
     dxtic = Ticdistlin(Xmin,Xmax,10,1) 
     xtic0 = Int(Xmin / dxtic) * dxtic
     If xtic0 < Xmin Then xtic0 = xtic0 + dxtic
     For xtic = xtic0 To Xmax_used Step dxtic
       Line (Xtic,Ymin_used) - (Xtic,Ymax_used)
     Next
  End If
  
  /'*** Logarithmic x scale ***'/  

  /'*** Linear y scale ***'/
  
  /'*** Logarithmic y scale ***'/
  /' Draw horizontal lines '/
  Dim Rlog(1 To 9) As single
  Dim Ytic As Single
  Dim Ltic As Single
  Dim I as Integer
  Ltic =  0.01 * (Xmax_used - Xmin_used)
  If ylinlog = 1 Then 
    For I = 1 To 9
      Rlog(I) = Log10(I)-1
    Next
    ' draw tic marks
    For Ytic = Int(ymin_used-1) To ymax_used Step 1
      Line (Xmin_used,Ytic) - (Xmax_used,Ytic)
    Next 
    For I = 1 To 9
      For Ytic = Rlog(I) To 3 Step 1
        Line (Xmin_used,Ytic) - (Xmin_used+Ltic,Ytic)
        Line (Xmax_used-Ltic,Ytic) - (Xmax_used,Ytic)
      Next
    Next 
  End If        
                         
End Sub                        


Dim As Single xmin(1 to 2), xmax(1 to 2), ymin(1 to 2), ymax(1 to 2)
xmin(1) = Zp/2 
xmax(1) = Zp + 2
ymin(1) = 0.1 
ymax(1) = 1000   

CreateFrame("Atomic number","mb",xmin(1),xmax(1),0,ymin(1),ymax(1),1, _ 
         50, 480, 20, 300)
 
xmin(2) = Ap/2 
xmax(2) = Ap + 2
ymin(2) = 0.1  
ymax(2) = 1000    
         
CreateFrame("Mass number","mb",xmin(2),xmax(2),0,ymin(2),ymax(2),1, _
         50, 480, 360, 640)

CreateArea(xmin(1),xmax(1),0,ymin(1),ymax(1),1,50, 480, 20, 300)

' draw a line with red colour
 Line (Zp,log10(Ymin(1))) - (Zp,log10(Ymax(1))), RGB(255,0,0)

' draw Z distribution
Scope
Dim As Integer I
For I = 1 To 100
   Logcircle(I,Zsum(I),Zp*0.004)
   '   	If AZ(I) > 10^Ymin Then Logcircle (I,AZ(I),Zt*0.002)
Next
End Scope



'CreateFrame("Mass number","mb",xmin(2),xmax(2),0,ymin(2),ymax(2),1, _
'         50, 480, 360, 640)



CreateArea(xmin(2),xmax(2),0,ymin(2),ymax(2),1,50, 480, 360, 640)

' draw a line with red colour
 Line (Ap,log10(Ymin(1))) - (Ap,log10(Ymax(1))), RGB(255,0,0)

' draw A distribution
Scope
Dim As Integer I
  For I = 1 To 250
    Logcircle(I,Asum(I),Ap*0.003)
   '   	If AZ(I) > 10^Ymin Then Logcircle (I,AZ(I),At*0.002)
  Next
End Scope


Sub Logcircle(X As Single, Y As Single, R As Single)
   Dim As Single U,V
   U = X
   V = Log10(Y)
   Circle (U,V),R,RGB(255,0,0),,,,F
End Sub

Sub Lincircle(X As Single, Y As Single, R As Single)
    Circle (X,Y),R,RGB(255,0,0),,,,F
End Sub

Sub Logline1(X1 As Single, Y1 As Single, X2 As Single, Y2 As Single)
  Dim As Single U1,V1,U2,V2
  U1 = X1
  V1 = log10(Y1)
  U2 = X2
  V2 = log10(Y2)
 ' Pset (U1,V1), RGB(200,0,0)
  Line (U1,V1) - (U2,V2), RGB(0,200,0)
End Sub

Sub Logline2(X As Single, Y As Single)
  Dim As Single U,V
  U = X
  V = log10(Y)
  Line - (U,V), RGB(0,200,0)
End Sub

Public Sub Logcross(X As Single, Y As Single, DY As Single)
  Dim As Single U,V,V1,V2
  U = X
  V = Log10(Y)
  V1 = Log10(Y-DY)
  V2 = Log10(Y+DY)
  Line (U-0.2,V) - (U+0.2,V)
  Line (U,V1) - (U,V2)
End Sub
